# Links:
  * Free 30 days game deploy site:
     https://gamebucket.io/
     http://www.sharemygame.com/share/670adeae-8a00-48ec-9a93-ab10243985ff1
  * Ben courses site:
     https://www.gamedev.tv/
     https://community.gamedev.tv/
  * Git repo:
     https://github.com/CompleteUnityDeveloper
     https://www.udemy.com/unitycourse/learn/v4/t/lecture/4695006?start=0
  * Hosting games on GitHub
     https://leereilly.net/2012/11/29/hosting-games-on-github.html
  * Unity 5.0 vs 4.0
     https://docs.google.com/document/d/1NkRIbKGZ5X3WbiWa3C4JFN7CAijLQBX-onJGoRagtD4/edit#
  * Unity knowlage base:
     https://unityads.unity3d.com/help/monetization/getting-started
     https://docs.unity3d.com/ScriptReference/Help.html
  * Unity learning sites:
     https://unity3d.com/learn
     https://unity3d.com/learn/resources/downloads
     https://unity3d.com/learn/tutorials
     https://unity3d.com/learn/tutorials/s/scripting
  * Unity certifications:
     https://certification.unity.com/?_ga=2.159644340.845566193.1528925424-2129492968.1528925424
     https://certification.unity.com/courseware?_ga=2.136139064.845566193.1528925424-2129492968.1528925424
     https://store.unity3d.com/products/education?_ga=2.89382546.845566193.1528925424-2129492968.1528925424
     https://certification.unity.com/get-certified
  * Tools for music:
     https://www.audacityteam.org/
  * Tools for images:
     https://www.gimp.org/
  * Free images
     googole.com (choose 'tools/usage rights/label for reuse and modifications')
  * Free fonts:
     www.dafont.com
  * Free sounds and music:
     www.freesound.org (choose 'Creative Commons' license, search for exaple for 'game music')
      After downloading file you can check file informations by 'right click/properites/details'.
  * Free assets/models/sprites:
     http://opengameart.org (space shooter redux)
  * Glitch garden assets:
     http://www.glitchthegame.com/public-domain-game-art/
  * Modifying sprite sheets:
     https://answers.unity.com/questions/563094/mobile-max-texture-size.html
     http://renderhjs.net/shoebox/ (will extract all images frome sprite sheets to own sprites)
     https://www.codeandweb.com/texturepacker (will repack them again to one sprite sheet)
  * Developer magazine:
     http://devmag.org.za
  * Andoird limitation changes:
     https://forums.coronalabs.com/topic/47214-android-2048x2048-image-limit-clarify/
     https://stackoverflow.com/questions/15313807/android-maximum-allowed-width-height-of-bitmap
  * Sites to paste and share code:
     In all of this sites below set Syntax Highlighting to C#
     http://pastebin.com      
     https://gist.github.com/
     http://instaco.de/
    
    
       
# Questions:
  * How to ask:
     Mark your question as [Help] and [Solved] at the beginning of the title
     Use a clear and descriptive title
     Use full sentences with correct grammar and punctuation
     Describe your problem thoroughly, format it as a bug report:
     Observed behaviour
     Expected behaviour
     Steps to reproduce
     List of things youve tried out already.
     Include errors and warning in full sentences
     Include version information
     Use Screenshots generously to show the problem.
      Take screenshots of both the entire window and the specific issue.
     Code formatting on general purpose forums leaves much to be desired
     Use the right tool for the job:
       http://pastebin.com
        - Set Syntax Highlighting to C#
       https://gist.github.com/
       http://instaco.de/
     Post complete files, point people to the appropriate line
  * Questions:
     Jak zatrzymac wykoanie kodu dopoki nie skonczy sie corutine?
     Na podstawie ponizszego artykulu wynika ze w szachach powinienem wywolac obrot kamery w 'LateUpdate'
      https://docs.unity3d.com/Manual/ExecutionOrder.html

  

# Build
  * Check your game window size
     Game tab/free aspect/add own sizes
     If there is a white text that mean you have to resize your window to see all game window
  * Setting of a game
     File/build settings
     Add a scene
     Player settings
  * For the web/Web GL
     Web player settings
      - width 600
      - height 800
      - black background
     Now build
     Zip the folder
     Go to gamebucket.io/upolad/choose zip/new tab in chrome will open/copy the address to share with someone 
      (30 days active)
     Now go to udemy.com/unitycourse(choos course)/choose lecture/wybierz dymki (3 ikona u gory)
     Facebook/UnityCourse

    
   
# Shortcuts
  * Film about shortcuts
     https://www.youtube.com/watch?v=yMqefz8XNC4
  * Duplictae 
     ctrl+d
  * Toglle between tabs (scene and game) 
     ctrl+1/2
  * Start game 
     ctrl+p
  * Pause game
     ctrl+shift+p
  * Align game object to view
     Select game object(e.g. camera) 
     Upper tools/Game object/Align view to selected
  * Move to the object in 'Scene' tab
     Select object/click on the scene/click F
     Alternative is double click on object in the hierarchy. 
  * Set camera to the point of view from ediotr scene
     Select camera/Ctrl+Shift+f
  * Move camera around the scene view
     Click and hold rmb + WSAD
  
  

# Profiler/optymalization:
  * Link for article:
     https://unity3d.com/learn/tutorials/temas/performance-optimization/profiler-window?playlist=44069
    
    
    
# Cahnging project from 3D to 2D
  * Edit/Project Settings/Editor/Default behavioral mode

  
  
# Namespaces
  * To find which namespace should you use to call/use method, you just need
    to go to unity manual/then find method/on the top of the article you will see namepace which you need to use   



# Changing playmode color
  * preferences/colors/playmode tint
  
  
  
# Show unity version
  * Debug.Log(System.Envirnment.Version);
  
  
  
# Write to console/Debug
  * Debug.Log("Hello World!");
  * print("Hello World!");
  * To get ID of instance of object use 'GetInstanceID()'
  
  
  
# Range
  * Example:
      // Autoload time.
      [Range (0.0F,15.0F)]
      public float auto_load_time=0.0F;
      
      
      
# Tooltip      
  * Example:
      // Spawn rate.
      [Tooltip ("Spawn rate of attacker")]
      public float spawn_rate=1.0F;
      
      
      
# Requiring components
  * Example:
      [RequireComponent(typeof(AttackerManager))]
      
      
      
# Hiding public variables in inspector
  * Example:
      // Spawn rate.
      [HideInInspector]
      public float spawn_rate=1.0F;
      
      
      
# Show private variables in inspector:
  * Example:
      // Spawn rate.
      [SerializeField]
      private int test;
  

  
# Leayout
  * If you changed by acciden layaout you could restore it to default
    (right upper corner, second combobox)
 
  
  
# Canvas
    * Canvas section/Render Mode/Screen Space - Overlay -> It means that canvas will be rendered on top of all objects

    
    
# Text
  * Game object/ui/text 
  * Enter UI view(fifth icone on top left corner)
  * Thanks to that you can snap text control to the center of canvas (you will see dottet white lines)
  * In the middle you will see anchor (looks like white flower :P)
  * At the beginning text is anchored to the center of the screen (not canvas)
  * Inspector/Anchor/schift -> pivot settings
  * Inspector/Anchor/alt -> position settings
  * Events System
     Manage events raised by UI elements (for example mouse click on button, joystick click, touchpad click)
  * UnityGUI
     Old way of handling UI, depracated
  * In script add namespace 'using UnityEngine.UI;'
    
    
    
# Btn/button
  * Add a text (will create canvas,text and events system)
  * Select text/add component/ui/button
  * Hover -> inspector/button/transition/color tint
  * Hover -> inspector/button/highlight color
  * Hover -> inspector/button/pressed color
  * Events:
     Create new object in hierarchy called 'LevelManager'
     Add script to 'LevelManager' - 'LevelManager'
     Open script/create in it new function 'public void LoadLevel(string name)'
     Hierarchy/select btn/inspector/events/add new
     Hierarchy/drag 'LoadLevel' game object to events in btn/then select 'LoadLevel' function/
      then write name of scene(level) to load
      
      

# Leveles(scenes) + Splash screen
  * To create levels or splash screen just create new scenes
  * After that go to file/build settings/drag and drop all scenes you want in game/prioritize them/close dialog
  * Now load level:
     Create new object in hierarchy called 'LevelManager'
     Add script to 'LevelManager' - 'LevelManager'
     Open script/create in it new function 
      public void LoadLevel(string name) 
      { 
        //Application.LoadLevel(name); Deprecated
        SceneManager.LoadScene(name);
      }
  * To close app:
     Use 'Application.Quit();'
     This function won't work on web deployment
     This function should not be used on mobiles(andorid,ios)      
  * To load next level (index is index of scenes in build)
     Application.LoadLevel(Application.loadedLevel+1); // Deprecated
     SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex+1);
  
  

# Export files (as a package)
  * Assets/package/export
  
  
  
# Music/Sounds/Audio
  * Background music
     After downloading sound to Unity check if sound is 3D (should be chcecked if game is 3D and unchecked if 2D)
     Set 'Loop' checkbox
     Create new empty game object 'MusicPlayer'
     After that, just drag music to that game object
     After that create script and add in 'Start()' this code :
        // Make sure that music will not stop after loading another scene.
        'GameObject.DontDestroyOnLoad(this.gameObject);'
  * Sound added as a event(use this if you dont want to use sound ONLY frome code):
     Select game object e.g. 'ball'
     Add component/Audio Listener
     Turn off 'Play on Awake'
     Add this code in collision method:
        // Play ball bounce.a
        this.GetComponent<AudioSource>().Play();
  * Sound added as a event 2 (when game object is being destroyed): 
     Add this code:
        // Audio clip with destroying effect.
        public AudioClip crack;
     Drag and drop aduio file to this field.
     Add this code in collision method:
        // Play crack sound.
        // AudioSource.PlayClipAtPoint is better than AudioSource.Play
        // becouse it will be played even if game object attached to it is destroyed
        AudioSource.PlayClipAtPoint(this.crack,this.transform.position);
  * Changine sound volume in all game world:
     Edit/Project Settings/Audio
  
  
  
# Singelton
  * Class that have only one instace
  
  
  
# Gimp
  * Site with info about pixel art:
     https://v-play.net/game-resources/make-pixel-art-online
  * Gimp tutorial:
     https://www.youtube.com/watch?time_continue=886&v=PONe4IIYSnQ
     https://www.youtube.com/watch?v=DCoTky6ddcU
  * Creating Sprite Sheet:
     Open gimp
     New/Create canvas
      Width - full brick + 1 pixel, height - (full brick +1) * number of bricks/advanced/background color - transparent
     To change/edit canvas size click view/change canvas size
     To change/edit background/layer size click layer/change layer size
     File/open as layer/find your image of the brick
     Tools/Transform tools/Move - move your image to correct place(do this with other images)
     Widnows/Docable Dialogues/Layers - will open layers tab on the right bottom corner (helpfull to manage all layers)
     In 'Layers' tab select layer/image you want to duplicate/duplicate it/move it to correct place
     In 'Layers' tab select layer/image you want to edit/select eraser or pencil/change your image (if you use eraser
      then after erasing there shuld be transparent background, not white)
      If you have problem with transparency after erasing just do this: 
         right click on the white space/select layers/transparency/add alpha chanel
         fuzzy select tool(wand icon)/select white spaces you want to make transparet with shift+lmb
         right click on the white space/edit/clear
     File/Export as png (JPG has to much artefacts, dont use it!)
      


# Sprites    
  * Sprites is rectangular version of texture (it can have multiple rectangular textures)
  * Sprite sheet shold be packed as much as you can (it will weight less)
  * Sprite sheets width and height shuld be make as power of to (mip mapping will work faster when 
    zooming out/in to sprite). You can see it in down right corner by adjusting slider.
    'NPOT' means 'Not a Power Of Two'
  * Loading Sprite Sheet into Unity:
     Drag and drop yor Sprite Sheet
     Select your Sprite Sheet/Pixel per unit - 128/Sprite Mode - Multiple/Applay  
     'Packing Tag' has only effect in unity pro version
     Set max size for 'Default' to maximum, so sprites will not render in lower quality
      But be carefull it will weight more MB
     Advanced/Mip mapping:
       High-resolution texture is scaled and filtred into multiple resolutions within texture file
       Takes up 33% more space
       Much fuster loading
       Don't use it if camera at fixed distance (for example ortogaphic)
     Select your Sprite Sheet/Sprite editor:
       Slice - automatic (check if this worked correctly by selecting images)
       Change names of images
       Check if pivot of images is in correct places (center or bottom left)
       Hit applay
  * Changing Sprite from code:
     this.GetComponent<SpriteRenderer>().sprite=this.sprites[this.max_hits-1];
  * Sprites rendering order
     'z' depth from transform will not have any effect on rednering,
      only sprite rendering order will have visual effect
     Edit/Project Settings/Tags and Layers/Reveal Sorting Layers/Add layers
     Now select e.g. ship/Sprite Renderer/Choose appropiate sorting layer
  * Sprite errors/problems:
     Check if your build created both an APK and an OBB file 
      (you can Google what the OBB file is for and find out quite easily). 
      The default setting for the Android builder is to split the build, 
      but under 100MB this is not necessary. You can turn it off from 
      Build Settings -> Player Settings -> Publishing Settings -> Split Application Binary.
      Below 100MB, with this option disabled you will only build an APK which can be distributed alone to other devices.
    
    
    
# Sprite Bones / Bone base animation:
  * Techique of cutiing sprite into pieces and then transforming them into new positions
    to create multiple sprites that will go to sprite sheet and then to animation  
  * Example: http://www.effecthub.com/item/300
  * Making bone base in GIMP:
     Import sprite 'Trophy' to gimp
     Image/Canvas Size/Increase ONLY height by 2px/Applay
     Layer/Layer to image size (yello underlininig box will hav size of canvas now)
     Tools/Selection tools/Rectangle select
     Select down part of sprite/Ctlr+x/Paste it 2px lower
     Save as '.png'
     Mow import it to unity
     Change 'Sprite mode' to 'Multiple'
     Sprite editor/Slice it/Move pivot point of sun piece to bottom center
     Now create empty g.o. called 'StarTrophy'
     Add to it two more g.o. called 'Top' and 'Bootom', each of them should have 
      'Sprite renderer' attached
     Reset all transforms
     Drage adn drop top and bottom elements of sprite to those objects
     Correct their transform so they look good
     Now make animations with those pieces
  
    
    
# Backgound/Sprites/Images/Textures:
  * Image
     Drag image to unity(should be type of 'Sprte 2D and UI)
     Game object/ui/image/then drag image to slot in inspector
       Reset 'Rect transform' and 'Scale'
     If you don't see lines when moving element on the scene then toggle rect transform in inspector (must be expanded)
     Select image
       Check 'Preserve Aspect'
       Click 'Set native Size'
     Select canvas:
       Renderer mode to 'Screen Space - Overlay'
       UI scale mode to 'Scale with screen size' (1600x900)
       Screen match mode to 'Shrink' 
        - If something will not match to the screen it will be cut off, so be carefull what zones will be cut off
        - If too many things will be cut off, you can change mode to 'Expand' 
          (will add black spaces on sides if necessery)
  * Background
     'z' position:
       Camera should be on -10
       Sprites should be on 0
       Background should be on 5
     All images you want use as a background shold have the same resolution 
     For 2D game camera should be set for 'Ortographic' (length from camera to object doesen't matter)
     On top of the viev are two buttons 'Center' and 'Global'. Change 'Center' to 'Pivot'
     In 'Game' tab change "aspect Ratio' to '4:3'.
      Ok, after some changes add custop resolution (800x600), detach game window and check if it works correct
     After you download backgound image you sholud thing wath resolution the game
      will use (for example 800/600 = 4/3)
     After that you drag and drop background to unity and reset it transform
     After that you set 'Pixels per unit' (800/16(number of blokcs) = 50) and change pivot to 'Bottom Left' 
      and hit 'Apply'
     Now check how many world tiles does background have in width and height
     Now change the 'Alpha' in the background by changing 'Color' in 'Inspector'
     Now set camera size and position to match background
  * Background with good aspect ratio (between 4:3 and 16:9) - UV mapping
     We want in ascpet ratio 4:3 that:
        width = 9 tiles
        height = width * (3/4) = 9 * (3/4) = 6.75 tiles
     Now 4:3 if you want to change this ratio to bigger, find lowest
      number that when ratio is multiplied by will give new ratio.
      In our case is either:
      16:4=4 (width/new_width) or 9:3=3 (height/new_height).
      3 is lower than 4, it means that our height will no change.
     Now
        new_height = old_height = 6.75 tiles
        new_width = new_height * (16/9) = 6,75 * (16/9) = 12 tiles 
     As you see above width will increase from 9 to 12. 
      It means we will be truncating some zones in the screen. 
      12-9=3 tiles. So on each side we will truncate 1,5 tiles.
     Finally 1 tile is 2 grass squares so we have to divide all above by 2.
        new_width = 12/2 = 6 tiles, 
        new_height = 6.75/2 = 3.375
     Add UI/canvas/name it 'LevelCanvas'
     Change render mode to 'World space'
     Reset transform
     Set Width=1600px and Height=900px
     Add UI/Raw Image on canvas/neame it 'Grass'
     Reset settings of raw image
     Drag and drop texture
     Set UV width to 6 tiles and UV height to 3.375
     Set width=1600px and height=900px of raw image
     Now add UI/Panel/name it 'CoreGame'
     Reset it
     Set width to 1200px (becouse 1600 * (3/4) = 1200px)
     Set height to 675px (becouse 1200 * (9/16) = 675px)
     Now set UV X and UV Y of raw image that at the left down bottom of
      'CoreGame' will start first tile        
     Select 'LevelCanvas' and set scale:
      12/1600 = 0.0075 in X and Y, Z=1
     Now select lizard and set 'Pixels per world unit' = 1600px/12tiles=133.3333
     Drop lizard to the game and check if it fits to one square
     Reset camera position
     Reset lizard/place it to x=1, y=1
     Now move 'LevelCanvas' so lizard will fit in first tile of 'CoreGame'
     Now set camera x=-10, 
     Now set camera size=height in tiles/2 = 6.75/2 = 3.375
     To check if all is good, go to game tab and change aspect ratio. 
      When changing all elements of game area should be visible.
     At the end you can change Edit/Snap Settings/ to 0.5 tile
  * Fade in/Fade out:
     Hierarchy/UI/Add new panel
     Select panel/Set 'source image' to nothing
     Add script that will change alpha chanell of panel
  * Textures
     Texture is just a bunch of pixels that are going to be applied to 2D surface(e.g. ball)
     Sprites is rectangular version of texture (it can have multiple rectangular textures)
     To add a texture select canvas/In hierarchy add/UI/Raw Image
     Textures are better for STATIC images that don't move e.g. background
     Image you want to set to that raw image must be typa of texture! 
    
  

# Physics
  * Rigidbody
     Mediates between object 'transform' and object 'colliders'
  * Colliders overview:
     https://docs.unity3d.com/Manual/CollidersOverview.html
     Static collider - object has collider but no rigidbody.
                        For static object for example walls, ground
     Rigidbody collider - object has collider and rigidbody. 
                           For objects that must have physics and are moving by physics, for example ball, spaceship
     Kinematic collider - object has collider and rigidbody and 'Kinematic' is checked on rigidbody. 
                           For objects that must have physics, you move them by your own(in code), not by physics
     Trigger collider - object has collider and 'IsTrigger' is checked on collider.
                         For objects that will not act like they have physics and are not moving.
  * To add physic moving, torque, etc to for example 'ball' just add component 'Rigidbody 2D' to object
  * ATTENTION: IF object movment is to fast it could intersect with other colliders.
     In thah cases use 'Continouse' collision detection on 'Rigidbody2D' (when the Collision Detection is set to 
      'Continuous', GameObjects with Rigidbody 2Ds and Collider 2Ds do not pass through each other during an update. 
      Instead, Unity calculates the first impact point of any of the Collider 2Ds, and moves the GameObject there. 
      Note that this takes more CPU time than Discrete.)
     Discrete collision updates the collider position once per fixed frame and detect collision between 
      the overlapping colliders. So if the object is fast enough to pass through the other in between fixed frames, 
      it wont hit. Thats why increasing the size of the collider helps too (although can result on strange behaves).
     Continuous collision makes the object trace the route and detect the collision with static colliders even 
      between frames. Objects with this mode wont pass through object with static colliders (without rigidbody), 
      although it will still be possible for it to pass through another game object with a non static collider.
     Dynamic continuous traces the route and cross the path with other continuous colliders looking for intersection, 
      so it can make it collide even if there are two fast moving objects. This mode prevents one continuous dynamic 
      collider from passing through continuous colliders, although it is still possible that it will pass through non
      static objects with Discrete collision.
  * Add 'Circe Collider 2D' 
     'Is trigger' should not be checked,if checked it will not bounce of objects - will ignore physics engine
  * Now add empty game object and attach new ' Box collider' to it (this will be your bottom border)
    witch 'Is trigger' on.
  * Now add script to game object
     Trigger collider:
      // When something hit bottom border(tutaj sam zderzak/collider zwizany z kolizj).
      // Trigger event (no physics) has no collisions, so we only get collider information.
      // private void OnTriggerEnter2D(Collider2D other)
      // Better approach is that on the bottom becouse it enuser that all comuting of collisions will happen
      // and after that we will for example destroy object
      private void OnTriggerExit2D(Collider2D collision)
     Collision collider:
      // When something hit bottom border(tutaj samo zdarzenie kolizji - zawiera wiecej informacji, np sie zderzenia).
      // private void OnCollisionEnter2D(Collision2D other)  
      // Better approach is that on the bottom becouse it enuser that all comuting of collisions will happen
      // and after that we will for example destroy object
      private void OnCollisionExit2D(Collision2D collision)
  * Now add paddle image + rigidbody(kinematic) + collider
  * Now Assets/Add material 2D/Set characteristic(for example half of energy is sqrt(0.5))/Set meterial to Paddle.
  * Set gravity scale to whole world
     Edit/Project Settings/Physics 2D
  * Snap objects to grid:
     Edit/Snap Settings/Set x,y(to the width and height of the brick)/Snap to All Axis
     Change mode to 'Move selected object(hand icon)'
     Drag bricks with ctrl pressed and they will snap to grid
     Works with multiselect
  * Layers
     Layers can help you set what objects collide with other object
     You can also use layers to stop the camera from rendering certain objects dynamically, 
     You can also use layers to apply lighting to only certain objects.
     In inspector, right upper corner choose 'Layers'/Add layers "Friendlies","Friendlies_Projectiles",
      "Enemies","Enemies_Projectiles"
     Set layers to appropiate game objects/prefabs
     Edit/Project Settings/Physics 2D/Turn off collision between apprpiate layers
  
  
  
# Script execution order
  * Somtimes its good idea to set scripts execution order by your self (for example
    i had some problems with comuting paddle and ball positions. First i should compute
    paddle position then ball position).
  * Edit/Project Setting/Script Execution Order/Add Paddle/Add Ball
  
  
  
# Unity does not support nested prefabs
  * That means that prefab cannot attach script from other prefabs
  
  
  
# Reference to other scripts attached to game object.
  * GameObject.FindObjectOfType<LevelManager>().LoadLevel("Lose");  
  
  
  
# Destroying objects  
  * Destroy(this); // Will destroy the script component that calls it (usually don't use it).
  * Destroy(gameObject,0.5f); // Will destroy GameObject and Component that script is attached to after 0.5 seconds. 
    
    
    
# Tags
  * Inspector/Add new tag 'Breakable'
  * Select bricks prefab and set tag to 'Breakable'
  * Now to check in code if object has tag just write:
     if(this.tag=="Breakable")...
     other.gameObject.CompareTag("player")
    
    
    
# Static - managing objects counter:
  * Declare in class:
      // Bricks counter.
      public static int counter=0;    
  * In 'Start()':
      // Actualize counter.
      counter++;
  * In ' OnCollisionExit2D()':
      // Actualize counter.
      counter--;
      // Destroy object.
      Destroy(this.gameObject);
      // Send information to load manager that brick was destroyed.
      this.level_manager.BrickDestroyed();
  * In 'LevelManager':
      // Function will run after brick is destroyed.
      public void BrickDestroyed()
      {
        // If there is no more bricks. 
        if(Brick.counter<1)
        {
          // Reset number of bricks(just in case some minor bugs).
          Brick.counter=0;
          // Load the next level.
          LoadNextLevel();
        }
      } // End of BrickDestroyed
      
      
      
# Cast as GameObject
  * GameObject x=Instatniate(...) as GameObject;



# Particle effects:
  * Some of the settng have little arrows next to setting.
    There are a lot of more settings there.
  * Particle system
     Duration  
       Duration of effect
     Looped
       Flag if effect is looped (duration will have no effect if looped)
     Prewarm
       Particles will be all ower the place. Like effect was played fo some time.
        Effect will have at start some particles emmited.
     Start delay
       Delay beetween starting effect after scene is loaded or triger is executed.
     Start lifitime
       Lifitime of each one particle
     Start speed
       Starting speed of particles
     Start size
       Starting size of particles
     Start rotation
       Starting rotation of particles
     Start color
       Starting color of particles
     Gravity modifier
       Force of gravity effecting particles
  * Emission
     Rate over time
       How many particles are emmited per second
     Rate over distance
       How many particles are emmited per unit(for exmaple 1 meter) of distance covered
        by particle system(particle system can also move - you can see this effect just by 
        moving particle system in editor view)
     Burst 
       Here you can manipulete bursts (many particles are emmitted at once).
        Usefull when e.g. you want to make explosion like effect
  * Shape(cone)
     First change view to 3D (is better to understand how those shapes look like)
     Emmit from
       Volume
        - particles will be genearated enywhere inside cone
  * Velocity over lifetime
     Velocity over lifettime of particle (continouse velocity, spedd will not increase!)
  * Limit Velocity over lifetime  
     Set limit to velocity of particles
  * Force over lifetime     
     Force will increase/cumulate over lifetime
  * Inherit velocity
     Flag if velocity should be inherited from pareten object
  * Color over lifetime
     Gradient of particle color changes over lifetime.
      Usfull for sparkles above fire changing from yellow to red to gray as they fade away.
  * Color by speed
     Particle have diffrent colors at diffrent speeds    
  * Size over lifetime
     Particles can e.g. shring over lifetime.    
      Usefull for flames shrinking going up.
  * Size by speed
     Smaller/bigger particles can have diffrent speed 
  * External forces
     Scale how much other forces (for exaple other explosion) will affect this
      particle system
  * Collision
     LOOK OUT. IF OVER DONE CAN HAVE BIG EFFECT ON COMPUTING!!!
     Planes
       Most efficient.
        Usefull when static particles system (e.g. torch) will hit static object (e.g. roof). 
        To see how it works just add some 'Plane' and see how particles are bouncing of it.
     World
       Very unefficient. 
        Partilces will collide with other world objects.
        They will not collide betweeen eyach other.
     Dumped
       How much velocity particles will lose after hitting something.
        It applies for all axes.
     Bounce
       How much velocity particles will lose after hitting something.
        It only applies to axis that hit take place.   
     Liftime lose
       Particles can lose e.g. half time otheir life (0.5) when hitting something
     Min kill speed
       Minimum speed of particle to be killed if it hit something
  * Subemmiters
     Partilces will emmit own particles.
  * Texture sheet animation
     You can designate whole sheet of textures(like sprite sheets) to diffrent particles 
      instead of one texture
  * Renderer mode
     Billboard
       2D flat image that alway look at the camera (2D particles will rotate alwayas to be
        face to camera, thanks to that they look like 3D)  
       Mesh
        - Only way to make true 3D texture particles
       Normal directions
        - How many particles will look at camera
       Material
        - Look of the particle
       Sort mode
        - Flag when to draw which particles (by priority/sort value)
       Sorting fudge
        - Flag with priorites of sorting are most important(will be drawn on top of other ones)
  * Creating onw material/texture for own particle model:
     Add image to unity (e.g. "heart.png")
     Create/Material/Name it "heart_particle"
     Select material/Drag image to texture slot
     Select material/Change shader/Particle/Additive
     Now just drag and drop this material to yor particle system
  * Downloading particles form assets store
     Window/Assets Store/Type "particle systems" in search window/Find "Simple Particle Pack"
     Import them to Unity
     Open scene from imported pack
     Run/Check appropriate filters
  * Downloading standard particles pack:
     Window/Assets Store/Type "standard assets" in search window/Find "Standard assets"
     Remember that they are old systmes. NOT SHURIKENS
    
      
      
# Clamping game to size of the any screen:
  * Example:
      // 0.5 for example is half of the screen. 
      // Boundries of the game.
      public float min_x;
      public float max_x;
      // Padding of player (for player not go out of boundries).
      public float padding=1.0F;
      // Left upper corner.
      Vector3 left_up= Camera.main.ViewportToWorldPoint(new Vector3(0,0,distance));
      // Right bottom corner.
      Vector3 right_down = Camera.main.ViewportToWorldPoint(new Vector3(1,1,distance));
      // Set min x.
      this.min_x=left_up.x+this.padding;
      // Set max x.
      this.max_x=right_down.x-this.padding;  
      
      
      
# Drawing gizmos:
  * Example:
      // Draw gizmos of game object, even if it is not selected..
      private void OnDrawGizmos()
      {
        Gizmos.DrawWireSphere(this.transform.position,1);
      } // End of OnDrawGizmos
      
      
      
# Loop over children of the object in hierarchy:
  * Example:
      // Loop over children of the object in hierarchy.
      foreach(Transform child in transform)
      {
        // Instantiate enemy.
        Instantiate(this.enemy_prefab,child.transform.position,Quaternion.identity,child.transform);
      }      
      
      
      
# Invoke
  * Easier version of coroutines, invoke(start up) function after given delay
  * Example:
      // Autoload next level.
      Invoke("LoadNextLevel",this.auto_load_time);
      
      
      
# InvokeRepeating
  * Calls function every time of given interval
  * 'CancelInvoke' stops 'InvokeRepeating' 
  * Usefull for launching multiple projectiles.
  * Example:
      // 0.0000001F - time before the first invokation. Essentially that should be 0.0F, but
      // sometimes it generate some bugs, 0.0000001F eliminate it.
      InvokeRepeating("ProjectileLaunch",0.0000001F,1);
  * Example (recursion):
      // Initialization of enemies until all position are taken.
      private void EnemiesSpawnUntilFull()
      {
        // Get free psition.
        Transform free=FormationFreeGet();
        // If there is free position.
        if(free!=null)
        {
          // Instantiate enemy.
          Instantiate(this.enemy_prefab,free.position,Quaternion.identity,free);
        }
        // If there is free position.
        if(FormationFreeGet()!=null)
        {
          // Initialization of enemies until all position are taken.
          Invoke("EnemiesSpawnUntilFull",this.enemy_spawn_delay);
        }
      } // End of EnemiesSpawnUntilFull
      
      
      
# Fire projectile over random time
  * Example:
      // Time.deltaTime guarantee that when FPS will drop down then propability
      // of launching projectile will go up.
      if(Random.value<Time.deltaTime*this.fire_rate)
      {
        // Launch projectile.
        ProjectileLaunch();
      }
  * Example:
      // Return information if is time to spawn passed attacker.
      private bool IsTimeToSpawn(AttackerManager attacker)
      {
        // Compute seconds to spawn to spawns per second.
        float spawn_per_seconds=1/attacker.seconds_to_spawn;
        // If spawns per second are too big compared to frame rate then debug warning.
        if(Time.deltaTime>spawn_per_seconds)
        {
          Debug.LogWarning("Spawn rate of attacker is too high compare to framerate");
        }
        // Time.deltaTime guarantee that when FPS will drop down then propability
        // of launching projectile will go up. Calculation is dividied by 5 becouse there is 
        // 5 lanes of attackers.
        return (Random.value<(Time.deltaTime*spawn_per_seconds/5));
      } // End of IsTimeToSpawn
      
      
      
# ChildCount
   'ChildCount()' will help you detect e.g. if all enemies on the board
    are detroyed, and then you can load new level.
   Thanks to that you don't need to have any static classes/fields



# Animation
  * Right click on one of the bottoms tab/Add animation tab
  * Drag and drop game object to the editor(e.g. enemy ship)
  * Select game object(ship)
  * Go to animation tab
  * Create new animation. This will add 'Animator'(added to game object) and 'Animation' (animation clip)
  * Select animation in 'Project' tab/Check or Uncheck 'Loop Time'
  * Select game object(ship)
  * Select 'Animation' tab
  * Add property - transform
     Will add first key frame at time 0.0 with default transform values
     Here you can manually change those values(better way of doing it will be describide below)
     Better way is to select appropiate key frame(white vertical line)/
      hit red button(now all chages made to ship will be saved in animation)/move,rotate,scale etc ship in the editor
     You can also hit play in this tab to see how animation will look like
     Futhermore, if you right click in the heading in timeline you can add event corresponded to the ship,
      e.g. 'Fire()' function
     To change time of keframe just drag and drop keframe by holding it first circle/point and move left/right
     Be carefull for other colliders when making animations (for example ship can start it animation in shreder and
      be destoryed just at the beginning!)
  * Additional in 'Animator' tab you can manage states of animation:
     Right click/Create Empty 'Idle' (will have no motion, and position realtive to parent) 
     Better way is to select ship/Add new Animation/Delete all timlines/At first timline reset all transform fields
      After that go to 'Animator' tab and connect appropiate states
      
      
      
# Animation from sprite sheet:
  * Create empty game object/name it 'Lizard'
  * Restet transform
  * Add animator to it
  * Create new empty g.o. named 'Body' as a child of 'Lizard' 
  * Add a sprite renderer to it
  * Create new Folders 'Animations/Lizard' 
  * Create new animaton controller in that folder e.g. 'Lizard'
  * Drag and drop that animator controler to the animator in 'Lizard'  g.o.
  * Add sprite sheet to folder 'Lizard'
  * Drag and drop one of the image from sprite sheet into sprite renderer
  * If background(canvas) is on top of sprite then change order in layer
  * Now move 'Lizard' g.o. to some filed e.g. x=2,y=2
  * If needed change scale (if you want to flip sprite just set x to -x)
  * Now select 'Body' and improve position of sprite
  * Go to animation tab
  * Create new animation e.g. 'Appearing'
  * Add new property/body/sprite renderer/sprite/ move both sprites to left side  
  * Drag and drop all images from sprite sheet to animation/Delete old first two/Move all sprites to beggining
  * Select 'animator' tab double click on state 'LizardAppering' - down left corner is animation preview
  * Modify samples value in 'Animation tab' to increase/decrease initial speed of animation 
  * Create new Clip 'Walking' and do the same as above
  * Go to 'Animator' tab/Select 'Appearing' state/Add transition/Select 'Walking' state
  * Select transition arrow/Set exit time/Set transition duration to 0
  * Additional parameters of transition
     In 'Animator' tab you can add own parameter e.g. 'is_attacking' and add it as a condition to transition
     Now select 'Lizard' g.o./Go to 'Animation' tab/select animation 'Walking'/Drag adn drop sprites/Select samples
  * To hide sprites in animation just add parameter 'Is active' to false
    
  

# Event when level is loaded:
  * Example:
      // Event - run when level was loaded.
      public void OnLevelWasLoaded(int level)
      {
        // Load music.
        audio_source.clip=this.audio_clips[level];
        // Play music.
        audio_source.Play();
      } // End of OnLevelWasLoaded


  
# Player Preferences/PlayerPrefs:
  * Slow to read and write. DON'T USE IT IN UPDATES METHODS
  * Max sie is 1MB
  * Support only int,float,string (no bool etc)
  * It is stored persistant(contant) in device storage. Even after turning on/off whole game.
  * Best way to use player prefs is to write own wrapper. 
    It will handle better multiple task and is far safer.
    
    
    
# Unity Remote
  * Project settings/Editor/Unity remote to 'Any android device'/Restart unity   
  * Set resolution in unity game tab to resolution of your phone  
  * On your mobile phone instal 'Unity remote'
  * Start app on mobile phone
  * Instalation guide:
     https://www.youtube.com/watch?v=H-jYAWtVnQA
    
    
    
# Materials
  * Right click/Create/Material/Name it 'Floor'
  * Drag and drop material to game object e.g. 'Cube'
  * Select material
  * Click little circle next to 'Albedo' and choose texture(for exampe 'Wood')
  * Select game object/Unfold 'Floor' material/First 'Tiling', set x and y
  
  
  
# Set camera to the point of view from ediotr scene
  * Select camera
  * Top toolsbar/Game object/Align with view
  * Shortcut is Ctrl+Shift+f
    
    
    
# 3D Models
  * Drag and drop model from blender
  * Select 'BowlingPin/Collider' element in the hierarchy
  * Remove Mesh collider(this was default mesh collider from blender)
  * Add Mesh collider/Select 'Convex' checkbox (wypukly)
  * Select Model in Project window/Unfold it elements/
     'Default take' and 'Avatar' are used for animation
    
    
    
# Two audio listeners on scene:
  * Remove audio listener from one of the object (e. 'TopCamera')
    
    
    
# Creating camera preview (RawImage):
  * Create new 'Renderer texture' in project view, named 'TopCamera'
  * Create new 'Camera' in hierarchy
     Select that camaera
     Set it position and projection
     Set it target texture to 'TopCamera'
  * Create new Canvas named 'UI'
     Set Renderer mode to 'Screen space-Camera'
     Add Panel named 'LeftPanel' 
       Set it position and size
       Set stretch to 'Left side' and position to 'Left side'
       Add RawImage named 'TopCameraPreview'
        - Set it position and size 
        - Set it texture to 'TopCamera'
        - Set stretch to 'Left side' and position to 'Left side'
     Add Panel named 'RightPanel'
       Set it position and size
       Set stretch to 'Right side' and position to 'Right side'
     Add Panel named 'TouchPad'
       Set it position and size
       Clear 'Source Image'
       Set color to full transparent
       In Inspector add Event/EventTrigger/PointerDown
        - Drag a ball prefab to it 
        - Choose 'DragStart()' method
       In Inspector add Event/EventTrigger/PointerUp
        - Drag a ball prefab to it 
        - Choose 'DragEnd()' method
  * To check if everything is ok:
     Go to Game tab
     Disconnect it from other tabs to be like a floating window
     Change size of window (changes will be seen only after you release left mouse button)
  
  
 
# Angles and rotations
  * Never read/change values of ratation by 'this.transform.rotation'.
    Always use 'this.transform.rotation.eulerAngles'???.
  * It always return angle > 0. Never returns negative values.
  
  
  
# Physics problems/errors debugging:
  * Run game, pause it, go frame by frame in the scene tab and check what is happening
  * Check if objects have colliders
  * Check if objects colliders are appropiate types
  * Check if objects colliders are triggers
  * Check if objects have rigidbodies
  * Check if objects rigidbodies are kinematic
  * Dismantle problem to smaller pieces, comment all lines of code and then uncomment
    each of them one by one
  * Exspose neccesery variables as public to see how they change in editor while game is running
  * Check if element putted on other element are not putted inside them.
    For example, you can have floor at the 'y=0' and put on it bowling pin, where bottom
    side of th pin could have 'y=-0.2' which can lead to bowlling pin falling through floor    
  * Check if colliders are not too thin by adujsting it width
  * Check if objects are not moving too fast by slowing them
  * Always use default physics material
     Dynamic Friction to 0.5
     Static Friction 0.5
     Bouciness 0.1
     Edit/Project Settings/Physics/Set default material
     Select all game objects that was already made and set them this material
  * Edit/Project Settings/Time
     Fixed timestep 0.02 - how rapidly physics engin computes collisions etc
  * Edit/Project Settings/Physics
     Nvidia PhysX system assumes that one worl unit equals 1 meter, so if you 
      are working in cm you shold multiplay almost all by 100    
     Gravity 9.81 (981 in cm)
     Bounce treshold 2 (200 in cm)
       Use this to set a velocity value. If two colliding objects have a relative velocity below this value, 
        they do not bounce off each other. This value also reduces jitter, so it is not recommended to set it 
        to a very low value.
     Sleep Threshold	0.005 (0,5 in cm)
       Use this to set a global energy threshold, below which a non-kinematic Rigidbody (that is, 
        one that is not controlled by the physics system) may go to sleep. When a Rigidbody is sleeping, 
        it is not updated every frame, making it less resource-intensive. 
        If a Rigidbodys kinetic energy divided by its mass is below this threshold, it is a candidate for sleeping.
     Default Contact Offset 0.01 (1 in cm)
       Use this to set the distance the collision detection system uses to generate collision contacts. 
        The value must be positive, and if set too close to zero, it can cause jitter. This is set to 0.01 by default. 
        Colliders only generate collision contacts if their distance is less than the sum of their contact offset 
        values.
     Default Solver 
       Iterations	Solvers are small physics engine tasks which determine a number of physics interactions,
        such as the movements of joints or managing contact between overlapping Rigidbody components. 
        Use Default Solver Iterations to define how many solver processes Unity runs on every physics frame. 
        This affects the quality of the solver output and its advisable to change the property in case non-default 
        Time.fixedDeltaTime is used, or the configuration is extra demanding. 
        Typically, its used to reduce the jitter resulting from joints or contacts.
     Default Solver Velocity Iterations
       Use this to set how many velocity processes a solver performs in each physics frame. 
        The more processes the solver performs, the higher the accuracy of the resulting exit velocity after a 
        Rigidbody bounce. If you experience problems with jointed Rigidbody components or Ragdolls moving too much 
        after collisions, try increasing this value.
  * Change 'Collision Detection' on game objects rigidbodies to 'Continoouse'
  * Change 'Drag' on game objects rigidbodies to for example '0.1'
  * Disable gravity of objects
  * Fading of animations could also make some problems (if two fnctions that should runa after each other are
    computing in the sam time)
  
  
  
# Qaternions/Rotations/Euler:
  * Quaternion.identity <=> Quaternion.Euler(0,0,0);
  
  
  
# Terrain
  * Create 3D Object/Terrain
  * Select Terrain/Clic Cog in Inspector/Set width and height
  * Import Envirment Package
  * Select Terrain/Clic PaintBrush in Inspector/
     Edit Textures/Select Albedo/Add Grass,Grass Rocky,Mud(with normal map)
     Paint terrain
  * Select Terrain/Clic PaintHeight/
     Set hight to 50
     Click Flatten(whole terrain will go up by 50, thx to that you can
      make caves etc).
     Painting in this mode make easier to build flat mountains
  * Create mountains at the edges of game area
  
  
  
# Lighting
  * First some info about lighting:    
     Direct 
       Bounce only once and hit an eye
     Indirect
       Bounce multiple times from many objects and hit an eye
     Volumetric lights 
       It is the light that catches litte dust particles like in forest or attic  
     Baked vs Realtime
       Baked light
        - heavy on RAM + HDD
        - Baked is pre-computed and saves the engine a ton of processing power when dealing with shadows in a scene. 
          So if you have a static light source and static objects (i.e. they don't move), then use baking
        - Baked light allows us to "wrap" objects in special "Lightmap" textures.
        - Looks good until we decide to move one of such game objects. 
          Because lightmaps are just textures, this immediately looks wrong.
          The entire process of "light bake" would have to be started over again to remove this incorrect appearance
        - Light maps, just require to compute all lighting before hand, storing it in Lightmap textures. 
          Then, when the player enjoys the game, her computer would only have to draw several extra textures 
          (which is a LOT quicker than computing real time global illumination)
        - Use it!
       Realtime light, espessially Global Illumination 
        - heavy on GPU + (sometimes on CPU).
        - Well, it can be very expensive, and the player would need at least GTX460+ series graphics card
          for good-looking, beautiful realtime light.
        - Realtime is, exactly what it sounds like, lighting calculated in real time. 
          It's quite expensive and if your game isn't all moving objects then you should learn how to bake and use 
          light probes and reflection probes    
     Scenet/combobox/
       Irradiance
        - This will show baked global ilumination (really check it after baking!)
       UV charts
        - Use it as described below?
       Systems
        - Flat surfaces on the same plane should be on the same system (eg flat flag on the wall should be one the same
          system like wall)
        - To improve it just go to lighting tab/object tab/advanced parameters/add new with positive value 
          (-1 is automatic)/Create it/ 
        - After that select meshes/go again to that ligting tab/Add all to this newly added layer/ CLICK BUILD!
     When making big elements like roofs/floars etc split it into separte meshes 
      (e.g. make 3 flat cubes than just one big cube for roof, thx to that when baking those elements
       will be computed in parrarel speeding things up)  
       
  * Edit/User Preferences
     GI Cache - clear it
    
  * Lighting tab
     Info
       When baking, you can improve lightmap quality by increasing the baked resolution slider 
        (40-100 texel resolution is reasonable), cranking up the ambient occlusion and enabling final gather. 
        Before baking, check your projects Quality & Player settings. 
        In the Quality tab, use hard and soft shadows with very high resolution. 
        In the Player tab, select the deferred renderer. You should disable precompute GI before you bake. 
        Even if you use lower quality shadows or a forward renderer at runtime, use these settings during lightmap 
        baking for best results. You can always switch back to forward rendering or lower graphics settings 
        after youre done baking.
     Statistic (2*512*512)
       2 lightmaps of 512*512 resolution
       Size (compressing will change it, you can observe it)
     Skybox material
       Set skybox - you can download asset 'AllSky' or 'Free hdr sky' (use it)
     Sun
       Set it to yor directional light   
     Enviroment Lighting
       Ambient Light
        - It is the darkest color it can be used in your scene
        - Generally set is as a gray/dark gray
     Realtime ligting
       Genearate at realitem shadows and lighting? Use only one 'Baked' or 'Realitime'
     Fog
       Use it to hide culled objects
       Set it color by using color picker to sky color
     Lightmapping settings
       Lightmapper        
        - Progressive - better but slower (use it)
        - Direct samples def is 32, set it to 8 (higher = better quality but slower to render, not slower to use, 
          and also dont increase size of lightmap), it is number of rays (promieni) used to computed lighting
        - Indirect samples def is 500, set it 128 (higher = better quality but slower to render, not slower to use, 
          and also dont increase size of lightmap), it is number of rays (promieni) used to computed lighting
        - Bounces def is 2, and set it to 2, this is number of bounces 
          (higher = better quality but slower to render, not slower to use, and also dont increase size of lightmap)
       Indirect resolution
        - It is GI(globa ilumination) direct lighting resolution (higher better quality but slower)
        - Set it to def 40 or litte higher up to 100  
       Lightmap padding 
        - Padding in lightmap helping to prevent bleeding (data from 2 parts of lightmap are intersecting on each 
          other making weird glitches). 
        - Set it to def 2
       Lightmap size
        - Bigger for bigger scenes, smaller for smaller scenes (for me 1000 or 2000)
       Compress lightmaps
        - If unchecked unity will generate better but bigger size lightmaps (use it?)       
       Ambient occlusion
        - Use it, it will increas a lot of light quality
        
  * Quality
     Info
       Quality is set to whole game (not to one scene)
       Green are default values for each platform
       You can set default quality levels for each platform by clicking arrows
     Pixel light count 
       How many lights can be shown at one object
       Bigger = better quality but slower
       Not that expensive for GPU and CPU
       Set it to min  10
     Texture quality
       Set it to 'Full res'
     Anisotropic textures
       Set it to 'Forced on'
     Antialiasing
       Disable it if you will use post processing
     Soft particles
       Disable it
     Shadows
       Set it to 'Soft and hard'
     Shadow Resolution
       Set it to 'High Resolution'
     Shadow projection
       Close fit = better but slower
       Stable fit = wore but faster (use it)
     Shadowmask 
       Set how shadows are computed 
       'Distance shadowmask' mean that only distant static objects shadows will used from baked texture
       'Shadowmask' mean that all static objects will be baked (use it), 
        non static objects will cast realtime shadows, but static objects will not cast shadows on them,
        to solve it just add light probes
     Shadow cascades
       Set it to max
     Shadow distance 
       Set it at least to 300
     Blend Weigths
       Set it to '4 bases'
     Vsync
       Set it to 'Every Vblank'
     LOD bias
       Level of Detail BIAS (LOD BIAS) controls at which distance from the viewer the switch to lower resolution mip 
        maps takes place. The standard value of the LOD BIAS is 0.0. 
        Some games force a negative LOD BIAS nevertheless. The result is heavy texture shimmering.
       LOD levels are chosen based on the onscreen size of an object. When the size is between two LOD levels, 
        the choice can be biased toward the less detailed or more detailed of the two models available. 
        This is set as a fraction from 0 to +infinity. When it is set between 0 and 1 it favors less detail. 
        A setting of more than 1 favors greater detail. For example, setting LOD Bias to 2 and having it change 
        at 50% distance, LOD actually only changes on 25%.
       Set it to '1'
     Max LOD level
       Models which have a LOD below the MaximumLOD level will not be used and omitted from the build
        (which will save storage and memory space). Unity will use the smallest LOD value from all the 
        Maximum LOD values linked with the quality settings for the target platform. If an LOD level is included 
        then models from that LODGroup will be included in the build and always loaded at runtime for that LODGroup, 
        regardless of the quality setting being used. As an example, if LOD level 0 is used in any quality setting 
        then all the LOD levels will be included in the build and all the referenced models loaded at runtime.
       This setting is poorly named. It should be called 'Best LOD level aviable' (LOD 0 is best, LOD 1 is worse etc)
       Set it to '0' to have all LOD levels used in game
     Particle raycas budget
       Set it to '4096'
          
  * Player settings
     Color space
       Gamma - faster, but uglier
       Linear - slower, but really good (use it)
     Batching
       Use it!
      
  * Post processing
     You can add also only simple effect like 'Screen space ambient occlusion' to your camer,
      that all of effects by dragging simple effect script to the camera
     Fog
       Def
     AntiAliasing
       Try 'Temporal' with def values, if it will be to much for PC change it to 'Fast aprox...'
     Ambient occlusion
       Def
       It is very heavy on computing so use is sparingly
     Depth of field
       Tick 'visualize' to sse what areas are used (white is blury parts, black is sharp/focus parts)
       Very expensive, use it sparingly
       Focus distance 5
       Aperture 2.7
       Use FOV disabled
       Focal length 50
       Kernel size Medium      
     Bloom
       Intensity 0.6
       Treshold 1.1
       Soft knee 0.6 
       Radius 4
       Anti flicker Enabled
       Dirt intensity 3
     Color grading
       Tonemapper - filmic
       Post exposure 1.1
       Temperature 5
       Saturation 1.1
       Contrast 1.05
      
  * In light 
     Firstly create 2 lights 
       Main light
       Rim Light (almost oposit 'y' rotation and blue tint)
     Mode
       Realtime - only compute light and shaows on realtime?
       Mixed - use bakead and realitime shadows (use it in your scenes)
       Baked - only use baked shadows
     Shadow type
       Type 
        - set it to soft shadows
       Normal Bias
        - Set it to 0 to reduce shadow artifacts
     Rendere mode
       Not important (vertex lighting) - faster
       Important (pixel lighting) - slower     
      
  * Main camera
     Clear flags
       Set it to 'Skybox'
     Background
       Set it to 'Black' without alpha
     Culling mask
       Set it to 'Everything'
     Projection
       Set it to your desire
     Field of view
       For FPS set it to '60'
     Clipping planes
       Near set to '0.3'
       Far set to the length of your map or as fits you 
     Rendering path
       When deciding between a forward or deferred renderer, keep in mind that we are only discussing realtime lights. 
        You can have as many baked lights as you wish in your scene. 
        Bake your lightmap, and disable them before runtime! 
        At runtime, the renderer only considers realtime lights in your scene.            
       Better not change it here (leava as default) and manage rendering path by 'Graphics Settings',
        which is more global and easier to manage
       Deffered 
        - Use it on desktop with many lights
        - Directional lights are very expensive in a deferred renderer.
          They affect the entire scene, with an enormous light volume.
        - No anti-aliasing support
       Forward 
        - Use it with mobile/vr with few lights
       Best to set it to 'Use graphic settings'
     Allow HDR     
       High Dynamic Range defines how very bright or dark colors are captured by cameras in scene
       It will be then associated wit 'Tonemapping' effect in post processing
       Use it!
     Allow MSAA (multi sampling anti aliasing)
       Dont use it (it will be used in post processing)!
      
  * Mesh/Model
     Tick checkbox 'Generate Ligthmap UV'
    
  * Terrain settings:
     Use lower resolutions and ensure everything is a power of 2
     My rule of thumb for desktops is to make all the resolutions half of the terrain size.
     For mobile you might make them a quarter or even and eighth of the terrain size.
     Make your terrains smaller and consider a tool like World Streamer that will only load the terrain if its in view.
     Use less textures  a maximum of 4 on low end systems
      Every multiple of 4 textures causes the unity terrain shader to render an additional pass 
      (draw the terrain all over again). So even adding 1 texture over this boundary of 4 will cause another pass.
     Use less different grasses  each additional grass consumes memory, rendering and culling overhead
     Either lose grass completely, or use it sparingly. It is a performance hog. In particular it will cause jitter 
      issues when it is culled. You can shrink the detail distance in your terrain settings, and also lessen the detail 
      density. Make sure that you color your grass so that it blends with the color of the terrain  this way you lessen
      the visual impact of hitting the detail distance.
     By default the camera will use frustrum culling to remove objects that are out of view on either side of the 
      current camera view, however you can get another level of performance as well by also using occlusion culling. 
      Occlusion culling will stop objects that are behind other objects from rendering and will result in more objects 
      being culled than just frustrum culling. Rendering less objects results means less draw calls and higher 
      performance. You can bake your occlusion culling via the occlusion culling window to generally get an immediate 
      performance improvement. TIP: Be creative during level design and use of larger objects such as mountains, hills 
      and walls in your scene. These will block your view of distant objects, and hence increase your framerate 
      via culling. 
      Window / Occlusion Culling. 
     Drop the size on your textures and normal maps to be more low end friendly. 
      Experiment with 256 and 512 sized textures
     Run a smooth or two on your terrain after you have finished stamping. 
      Smoothing the terrain reduces the number of polys that need to be rendered.
     Increase the Pixel error on your terrain. This will have the effect of reducing more distant terrain at a lower 
      resolution (LOD), but will also increase visual artifacts as you move around. 
      Experiment until you find a trade off you are happy with.
     Use mobile optimized trees. The tree samples provided with Gaia are desktop trees. 
      If using SpeedTree, experiment with your LOD and wind settings. Preferably lose wind completely.
     Lose Unity water completely. The default Unity water is very inefficient. If you must use Unity water then swap 
      it out for the WaterBasicDaytime version that comes in Standard Assets / Environment / Water Basic. Better 
      yet purchase a good quality 3rd party water shader optimized for mobile such as AQUAS.
     Make sure you mark rocks and other assets that wont move as static, this will allow unity to batch them, which in 
      turn reduces draw calls and increases frame rate. Make sure when you spawn these assets that their scale is a 
      whole number and this will allow Unity to choose the best case between dynamic and static batching.
     Instance as much as you can. Instancing is the process of sending the object to the GPU once, and then rendering
      it multiple times, as compared to sending it to the GPU for every single time it needs to be rendered. 
     GPU instancing:
      https://docs.unity3d.com/Manual/GPUInstancing.html
     Example of GPU instancing of trees:
      - http://www.procedural-worlds.com/gaia/tutorials/optimising-speedtree-with-gpu-instancing-in-unity-55/
      - Go into your terrain settings and disable bake light probes for trees.
      - Go into your tree settings and disable light probes for all the LODs. 
        Also think about disabling shadows for lower LODs as their impact as it can be significant.
      - Billboard LOD/Culled  If you drag this setting to the left, this will move the billboards closer, 
        and distant SpeedTrees will be completely culled, and this can make a big difference as well. 
        Tweak it until the distance is right for your scene.
      - You will need to do this for every type of tree in your scene and this alone will provide a significant 
        frame rate boost. However there is more you can do.
      - Check your GI / lighting settings. The following settings are generally good settings for an open world. 
        Note that I am not using the SkyBox for my ambient light as this is slower. 
        I have also dropped the resolution on my precomputed GI, and removed baked GI completely.
      - Now lets look at your general quality settings. The shadow distance is one of the killer settings here. 
        The lower you make it, the less your graphics card needs to do, and the better the frame rate you will get. 
        Also explore the LOD bias. This will change the distance at which lower LODs kick in, and can also 
        significantly improve performance. Note: You can change these settings for each quality level.
      - Now look at your Graphics Settings. You will get better performance with deffered lighting.
      - And your light  i prefer soft shadows.
      - And then your camera. You want HDR for better lighting and you want draw as little as possible. To reduce what 
        you need to draw reduce the Far Clipping Plane. If you draw less then you will increase your frame rate, 
        so its a balance. Use things like fog to artfully hide the far distance (and hence not have to draw it).
     In your lighting tab, select either Precomputed Realtime GI, or Baked GI, but not both. 
      You will need to update the lights in your scene to reflect the settings you have chosen.
     In your lighting tab, make your ambient light source a fixed color. 
      This is less GPU intensive than using the Skybox.
     In your lighting tab, make your sky a non procedural Skybox instead of the default procedural Skybox. 
      Its much cheaper often looks better.
     Use baked lighting if you can get away with it. The means you lose the benefit of time of day lighting, 
      but you get it back in performance. If you remove shadows and other lighting calculations then this 
      reduces the amount of work the device has to do.
     Use Forward instead of Deferred rendering path. This is cheaper for environments that have a single light e.g. 
      the sun. It will perform words however if there are multiple lights in the scene. You will find this setting 
      under Player Settings. File -> Build Settings -> Player Settings. If you have multiple lights however, 
      Deferred will be faster and better.
     In your scripts, never leave the Update method if the script does nothing  this chews up cpu even if its empty. 
      If you must do something regularly, then consider using co-routines, or using a master manager component.
     In your scripts, always cache transforms and components, its much cheaper than getting them during Update.
     In your scripts, never use methods like Find(), except perhaps in Start(), its very expensive.
     In your scripts, avoid using Vector3.Distance(), use Vector3.sqrMagnitude instead.
     In your scripts, avoid using Ray casting, and if you must use, then use sparingly.
     When using colliders, in order of cheapest to most expensive, use Sphere, Capsule, Cube, Mesh, Convex Mesh. 
      Mesh colliders are way more expensive, so estimate the collision volume with a sphere or capsule if you can.
     Set per layer cull distances on your camera using Camera.layerCullDistances
     Finally check settings of your terrain with those thye have given
     Batching:
      - https://blogs.unity3d.com/2017/04/03/how-to-see-why-your-draw-calls-are-not-batched-in-5-6/
     Optymaizing hierarchy
      - https://blogs.unity3d.com/2017/06/29/best-practices-from-the-spotlight-team-optimizing-the-hierarchy/
     Optimization Guide
      - https://software.intel.com/en-us/android/articles/unity-optimization-guide-for-x86-android-part-1  
    
    * The best way to profile is on a compiled build. Be sure you disable vsync to stop it from influencing your 
      profile. However even profiling in the editor is enough to show you where the bottlenecks are likely to be.
  
  
  
# Tilemaps:
  * Import sprite
  * Set appropiate size
  * Edit sprite
     Slice if needed
     Set own outline if needed
     Set own physics if needed
  * Create new tilemap
     Set it to appropiate layer
     Set 'Tilemap renderer' to appropiate layer
     Add rigidbody if needed
       Set as static if needed
     Add collider if needed
       Set as 'Used by composite' if needed
     Add composite collider if needed
       Set as trigger if needed
       Set it to 'polygons' if ypu see some player jitter when playing
      
      I am not an expert, but my guess is thath when your player is jumping and moving verticaly 
      is has velocit in 'x' and 'y'. So it could fall off the ladder becouse of 'x' velocity.

      Second guess is post above about laddedr physics collider shape.
      
  
# Jumping (player fall down faster than moving up, like in mario):

    [SerializeField] [Range(1f, 5f)] float gravityMultiplier;
    float originalGravity;
    bool changedGravity = false;
     
    void Start () 
    {
        rigidbody = GetComponent<Rigidbody2D>();
        originalGravity = rigidbody.gravityScale;
    }
     
    void AlterJumpGravity() 
    {
        if (rigidbody.velocity.y < 0 && !changedGravity) 
        {
            rigidbody.gravityScale = originalGravity * gravityMultiplier;
            changedGravity = true;
        }
        if (changedGravity && rigidbody.velocity.y >= 0) 
        {
            rigidbody.gravityScale = originalGravity;
            changedGravity = false;
        }
    }
   
  // Jump gravity multilplier when player is falling down.
  [SerializeField]
  [Range(0.1F,10.0F)]
  [Tooltip("Jump gravity multilplier when player is falling down")]
  private float jump_gravity_multiplier = 1.5F;
    
  // Alter player gravity when jump is in progress.
  void JumpGravityAlter()
  {
    // If jump is not in progress then exit from function.
    if(this.is_up_jump_in_progress)
    {
      return;
    }
    // Change gravity.
    this.rbdy.gravityScale = this.initial_grav_scale * this.jump_gravity_multiplier;    
  } // End of JumpGravityAlter
    
    
    
# Checking if player is on the ground before jump (to disallow jumping in mid air):
   Edit > Project Settings > Physics2D > Uncheck "queries start in colliders" 
   Code:
    private bool IsOnGround()
      {
        Vector2 startLeft = new Vector2(transform.position.x - PlayerCollider.bounds.extents.x, 
                                        transform.position.y - PlayerCollider.bounds.extents.y);
        Vector2 startRight = new Vector2(startLeft.x + PlayerCollider.bounds.extents.x * 2, startLeft.y);
        return (Physics2D.Raycast(startLeft, Vector2.down, 0.01f).collider != null) || 
               (Physics2D.Raycast(startRight, Vector2.down, 0.01f).collider != null);
      }    
  
  
# Multi jump:
    using UnityEngine;
     
    public class PlayerController : MonoBehaviour 
    {
      public float speed = 3f;
      public float jumpForce = 12f;
      public float firstJumpForce = 8f;
      public int jumps = 2;
   
      private int remainingJumps;
      private float x;
      private Animator animator;
      private Rigidbody2D rigidbody;
      private CapsuleCollider2D bodyCollider;
      private BoxCollider2D feetCollider;
   
      // Use this for initialization
      void Awake () 
      {
          animator = GetComponent<Animator>();
          rigidbody = GetComponent<Rigidbody2D>();
          feetCollider = GetComponent<BoxCollider2D>();
          bodyCollider = GetComponent<CapsuleCollider2D>();
      }
      
      // Update is called once per frame
      void Update () 
      {
          Run(Input.GetAxis("Horizontal"));
      }
      
      void FixedUpdate() 
      {
        if (feetCollider.IsTouchingLayers(LayerMask.GetMask("World"))) 
        {
          remainingJumps = jumps;
        }
        if(Input.GetButtonDown("Jump")) 
        {
          Jump();
        }
      }
      
      // Forces should be computed in fixed update becouse it is part of physics.
      private void Jump() 
      {
        if((feetCollider.IsTouchingLayers(LayerMask.GetMask("World")) || remainingJumps > 0)) 
        {
          if(remainingJumps == jumps) 
          {
            rigidbody.AddForce(Vector2.up * firstJumpForce, ForceMode2D.Impulse);
          } 
          else 
          {
            rigidbody.AddForce(Vector2.up * jumpForce, ForceMode2D.Impulse);
          }
          remainingJumps--;
        }
      }
      
      private void Run(float x) 
      {
        if (x == 0) 
        {
          animator.SetBool("isRunning", false);
          return;
        }
        animator.SetBool("isRunning", true);
        transform.Translate(Vector2.right * x * speed * Time.deltaTime);
        transform.localScale = new Vector2(Mathf.Sign(x),1);
      }
    }  
  
  
# Climb ladder (handled by animation state)
    private void ClimbLadder()
    {
      if (!_collider2D.IsTouchingLayers(LayerMask.GetMask("Climbing")))
      {
          ResetClimbingState();
          return;
      }

      float controlThrow = CrossPlatformInputManager.GetAxis("Vertical"); // value is between -1 to +1.
      Vector2 climbVelocity = new Vector2(_rigidbody2D.velocity.x, controlThrow * _climbSpeed);
      _rigidbody2D.velocity = climbVelocity;

      SetClimbingState(controlThrow);
    }

    private void ResetClimbingState()
    {
      _rigidbody2D.gravityScale = _initialGravityScale;
      _animator.SetBool("isClimbing", false);
      _animator.SetBool("isClimbIdling", false);
    }

    private void SetClimbingState(float controlThrow)
    {
      if (!_collider2D.IsTouchingLayers(LayerMask.GetMask("Ground")))
      {
        _animator.SetBool("isClimbing", true);

        if (controlThrow == 0)
        {
          _rigidbody2D.gravityScale = 0;
          _animator.SetBool("isClimbIdling", true);
        }
        else
        {
          _rigidbody2D.gravityScale = _initialGravityScale;
          _animator.SetBool("isClimbIdling", false);
        }
      }
      else
      {
        _animator.SetBool("isClimbing", false);
      }
    }



# Cieneammachine
   * It is usefull for camera managing
   * You can download it via package manager
   * Select main camera
      Add 'Cinemamachine Brain'
      Create new game object called 'Cameras' and drag main camera there
      Add new cinemamchine camera eg. 'Camera 2D'
      Set appropiate values to that new virtual camera
      Add cinemachine confiner to bound camera movement
      Add 'Player' and 'Background' to new layers
      Go to 'Physics 2D' and turn off colliding with background
      Select bacground and add 'Polygon collider' (set appropiate values)
      Drag and drop background to virtual camera confiner
  * Stat driven cameras:
     Add state driven camera
     Parent it to 'cameras' game object
     Parent existing virtual camera to state driven camera
     Delete default created 'CM vcam1' camera
     Now if you select state driven camera in inspector you should see that virtual camera is 
      a child of it
     Change name of virtual camera to 'VirtualCameraRun'
     Create virtual camera to 'VirtualCameraIdle' (best by duplicating run camera)
     Select state driven camera
       Set player as target animation
       Add new state
         Select 'Idle'
         Select 'VirtualCameraIdle'
         Set wait time
       Add new state
         Select 'Run'
         Select 'VirtualCameraRun'
         Set wait time
       Change size of both cameras (idle lower than run)
       Play to check if cameras are working good
       Select state driven camera
         Create own blend ('Add asset'), save it in animations folder
         Add new blend
         Set it values
         Do this for all state changes
     Select state driven camera
       Add noise
       Set ip up
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
 
  
  
    



